
#include "md5_dgst.c"

#define HMAC_OPAD	0x5C
#define HMAC_IPAD	0x36

//calculates hmac_md5
void hash_md5(unsigned char *in, int inlen, unsigned char *key, int keylen, unsigned char *out)
{
	MD5_CTX md5Info;
	unsigned char digestBuffer[MD5_CBLOCK], hashBuffer[MD5_CBLOCK];
	int i;

	MD5_Init(&md5Info);

	// in hmacMD5InitKey
	memset( hashBuffer, HMAC_IPAD, MD5_CBLOCK );
	memcpy( hashBuffer, key, keylen);
	for( i = 0; i < keylen; i++ )
		hashBuffer[i] ^= HMAC_IPAD;
	MD5_Update(&md5Info, hashBuffer, MD5_CBLOCK);
	memset(hashBuffer, 0, MD5_CBLOCK);

	// first call to hmacMD5Hash
	MD5_Update(&md5Info, in, inlen);

	// second call to hmacMD5Hash
	MD5_Final(digestBuffer, &md5Info);

	memset( hashBuffer, HMAC_OPAD, MD5_CBLOCK );
	memcpy( hashBuffer, key, keylen);
	for( i = 0; i < keylen; i++ )
       		hashBuffer[i] ^= HMAC_OPAD;
       	MD5_Init(&md5Info);
       	MD5_Update(&md5Info, hashBuffer, MD5_CBLOCK);
       	memset(hashBuffer, 0, MD5_CBLOCK);
       	MD5_Update(&md5Info, digestBuffer, MD5_DIGEST_LENGTH);
       	memset(digestBuffer, 0, MD5_DIGEST_LENGTH);
       	MD5_Final(out, &md5Info);
}


