# Makefile for a basic kernel module
# 

include $(TOPDIR)/Rules.make

#Old includes
#CC=gcc
#MODCFLAGS = -I/lib/modules/2.2.13-rtl2.0/build/include -Wall -DMODULE -D__KERNEL__ -DLINUX -I. -DDEBUG -DNDEBUG -ggdb -DEXPORT_SYMTAB -O2
#USRCFLAGS := -Wall -D__KERNEL__ -DLINUX -I. -ggdb 
INCLUDE -= -D__KERNEL -DMODULE

SRC = rsa.c mpi-add.c mpi-bit.c mpi-cmp.c mpicoder.c mpi-div.c mpi-gcd.c mpih-cmp.c mpih-div.c mpih-mul.c mpi-inline.c mpi-inv.c mpi-mpow.c mpi-mul.c mpi-pow.c mpi-scan.c mpiutil.c mpih-add1.S mpih-lshift.S mpih-mul1.S mpih-mul2.S mpih-mul3.S mpih-rshift.S mpih-sub1.S primegen.c errors.c random.c

MPI_SRC = mpi-add.c \
	mpi-bit.c \
	mpi-cmp.c \
	mpicoder.c \
	mpi-div.c \
	mpi-gcd.c \
	mpih-cmp.c \
	mpih-div.c \
	mpih-mul.c \
	mpi-inline.c \
	mpi-inv.c \
	mpi-mpow.c \
	mpi-mul.c \
	mpi-pow.c \
	mpi-scan.c \
	mpiutil.c \
	primegen.c 

MPI_OBJ = mpi-add.o \
	mpi-bit.o \
	mpi-cmp.o \
	mpicoder.o \
	mpi-div.o \
	mpi-gcd.o\
	mpih-cmp.o \
	mpih-div.o \
	mpih-mul.o \
	mpi-inline.o \
	mpi-inv.o \
	mpi-mpow.o \
	mpi-mul.o \
	mpi-pow.o \
	mpi-scan.o \
	mpiutil.o \
	primegen.o 

MPI_ASM = mpih-add1.o \
	mpih-lshift.o \
	mpih-mul1.o \
	mpih-mul2.o \
	mpih-mul3.o \
	mpih-rshift.o \
	mpih-sub1.o 


all: clean rsa.o mpi.o 

rsa.o:	rsa.c
		$(CC) ${INCLUDE} -I $(TOPDIR)/crypto -I $(TOPDIR)/crypto/hash -c rsa.c -o rsa-lib.o

mpi.o:	$(MPI_OBJ) $(MPI_ASM)
	ld -o mpi-lib.o -r $(MPI_OBJ) $(MPI_ASM)

%.o: %.c
	$(CC) $(INCLUDE) -c '$<'

.S.o:
	$(CC) $(INCLUDE) -c '$<'

clean:
	-rm -f $(MPI_OBJ) $(MPI_ASM)
