/*
 *	RTetherdevice.h
 *	based on <include/linux/etherdevice.c>	
 *
 *	RT-INET 1.0
 *
 *	(C)2002, Navigators Group	<www.navigators.di.fc.ul.pt>
 *		 Pedro Martins		<pmartins@di.fc.ul.pt>
 *	
 *	Ethernet-type device handling
 *
 * 	Last Review Date: XX
*/

#ifndef _RTetherdevice
#define _RTetherdevice

#include <linux/if_ether.h>
#include "rtip/RTdev.h"
#include "rtip/RTskbuff.h"

extern int		RTeth_header(struct RTsk_buff *skb, struct RTnet_device *dev,
				   unsigned short type, void *daddr,
				   void *saddr, unsigned len);
extern unsigned short	RTeth_type_trans(struct RTsk_buff *skb, struct RTnet_device *dev);		   
	   	   
#if 0		   
extern int		eth_rebuild_header(struct sk_buff *skb);
extern unsigned short	eth_type_trans(struct sk_buff *skb, struct net_device *dev);
extern void		eth_header_cache_update(struct hh_cache *hh, struct net_device *dev,
						unsigned char * haddr);
extern int		eth_header_cache(struct neighbour *neigh,
					 struct hh_cache *hh);
extern int		eth_header_parse(struct sk_buff *skb,
					 unsigned char *haddr);
extern struct net_device *init_etherdev(struct net_device *dev, int sizeof_priv);
extern struct net_device *alloc_etherdev(int sizeof_priv);

static inline void eth_copy_and_sum (struct sk_buff *dest, unsigned char *src, int len, int base)
{
	memcpy (dest->data, src, len);
}

/**
 * is_valid_ether_addr - Determine if the given Ethernet address is valid
 * @addr: Pointer to a six-byte array containing the Ethernet address
 *
 * Check that the Ethernet address (MAC) is not 00:00:00:00:00:00, is not
 * a multicast address, and is not FF:FF:FF:FF:FF:FF.  The multicast
 * and FF:FF:... tests are combined into the single test "!(addr[0]&1)".
 *
 * Return true if the address is valid.
 */
static inline int is_valid_ether_addr( u8 *addr )
{
	const char zaddr[6] = {0,};

	return !(addr[0]&1) && memcmp( addr, zaddr, 6);
}

#endif

#endif	
