// ============================
// ttcb.h -- included in tcb.h
// ============================
#include "share_app_ttcb.h"

#define openTTCBConnection openTCBConnection
// --------------------
// TTCB API
// --------------------

// Most functions have two structures, used for the in and out parameters.
// The use of structures allows one to use the same interface with plaintext and encrypted parameters.
// Each structure has a trailer ir order for its size to be multiple of 64 (we consider block ciphers that
// transform 64 bits plaintext in 64 bits cyphertex. The maximum size of the keys are given by skey_t)


void closeTTCBConnection(descriptor_t *descriptor, error_out_t *out);

//-----------------
// Agreement service

void propose(descriptor_t *descriptor, elist_t elist, TCBtimestamp tstart, decision_t decision, value_t value, propose_out_t *out); 
void decide(descriptor_t *descriptor, tag_t tag, decide_out_t *out);

//-----------------
// Random Number service

void getRandom(descriptor_t *descriptor, rand_out_t *out);


//-----------------
// Other APIs

void getLocalTTCBid(descriptor_t *descriptor, localTTCBid_out_t *out);

void crashedLocalTTCBid(descriptor_t *descriptor, localTTCBid_t localTTCBid, error_out_t *out);
void crashedLocalTTCBeid(descriptor_t *descriptor, eid_t eid, error_out_t *out);



void print_error_TTCB(int err);

