
// ttcb_module.h

#include "share_app_ttcb.h"

// message formats

/* A versao corrente do formato das mensagens :

| hdr tcb | fields tcb .... | header agreement | fields agreement......|

*/


/*
+-------------------------------------------+
| AGREEMENT                                         |
+-------------------------------------------+
*/


typedef struct {  /* CSTable - table to be transmitted */
        elist_t elist;
        TCBtimestamp tstart;
        decision_t decision;
        eid_t eid;
        value_t value;
} CSTable_field;

//tstart = 0 means no info






struct ent_dat {  // entity description array
	skey_t secret;
	protection_t protection;
	seq_t seq; // current sequence number
	char is_free; // 0 no, 1 yes
} entities_data[MAX_LOCAL_ENTITIES]; // eid = local TTCB id + index



tag_t last_tag = 0;


unsigned this_local_TTCB_id = 0;


// Agreement

struct cdt {  // CDTable - running agreements data
	tag_t tag;
	decision_t decision;
	elist_t elist;
	TCBtimestamp tstart;
	struct {
		value_t value;
		char is_free; // 0 no, 1 yes 
	} vtable[MAX_SIZE_ELIST]; // vtable[i] has the value correspondent to the entity in elist[i]
	char is_free; // 0 no, 1 yes
} CDTable[MAX_AGREEMENTS];


/* Od = 0 ; isto nao estaria ja feito na TCB?
struct rt {   Rtable - received messages
	?? mid;
	round;
} Rtable[....];
*/

CSTable_field CSTable[MAX_FIELDS_CSTABLE];
int first_CSTable_reg_free = 0;

int max_fields_agreement = 0;



// prototypes

short search_CDTable(elist_t elist, TCBtimestamp tstart, decision_t decision);
short search_CDTable_tag(tag_t tag);
short get_freeR_in_CDTable(void);
short count_freeR_in_CDTable(void);
short get_freeR_in_entities_data(void);
short index_eid_in_elist(eid_t eid, elist_t elist);
tag_t get_tag(void);
void initVariablesTTCB(void);
void process_input(int fifo, ReqTcbHeader reqHead, in_hdr_t *in, int size_out);
void process_output(int fifo, out_hdr_t *out, int len, eid_t eid, protection_t protection, skey_t secret, seq_t seq);
void TTCBlocalAuthentication(int fifo, char *buff, int sizeofmsg);
void TTCBend_connection(int fifo, eid_in_t *in);
void TTCBpropose(int fifo, propose_in_t *in);
void TTCBdecide(int fifo, decide_in_t *in);
void TTCBrandom(int fifo, eid_in_t *in);
void TTCBcrashedLocalTTCBid(int fifo, localTTCBid_in_t *in);
void TTCBcrashedLocalTTCBeid(int fifo, eid_in_t *in);
