package ttcb;
// import java.lang.Number;
/**
 * Title:        TTCB for Java
 * Description:  Implementing a class that encapsulates TTCB C code.
 * Copyright:    Copyright (c) 2001
 * Company:      LASIGE-DI-FC-UL
 * @author Lau Cheuk Lung
 * @version 1.0
 */

public class share_app_ttcb {
// From TCB
  public static final byte OK			      = 0;
  public static final byte TCB_ACESS_ERROR	      = -1;   // Erro no acesso a tcb
  public static final byte NO_AVAIL_CONN	      = -2;   // Conexao indisponivel
  public static final byte NO_AVAIL_LOCAL_MEASURE     = -3;   // medicao local nao disponivel
  public static final byte INVALID_LOCALM_DESC	      = -4;   // descriptor de medicao local invalido
  public static final byte NO_AVAIL_EXEC	      = -5;   // execucao nao disponivel
  public static final byte FUNC_NOT_FOUND	      = -6;   // funcao nao encontrada
  public static final byte WCET_FUNC_NOT_FOUND	      = -7;   // funcao wcet nao encontrada
  public static final byte CANT_RUN_TIMELY	      = -8;   // nao consegue correr atempadamente
  public static final byte NO_AVAIL_LOCAL_FD	      = -9;   // detector de falhas local nao disponivel
  public static final byte ALREADY_FAILED             = -10;  // a tcb detectou que a falha deu-se antes de processar o pedido
  public static final byte INVALID_LOCALFD_DESC       = -11;  // descriptor de deteccao de falhas locais
  public static final byte TOO_MANY_DISTRIBUTED_FD    = -12;  // demasiadas deteccoes simultaneas
  public static final byte BURSTY_SENDS	              = -13;  // demasiados sends no round
  public static final byte IN_INIT_STATE	      = -14;  // a tcb enconta-se em fase de inicializacao
// ERRORS RETURNED
  public static final byte PARAM_OUT_OF_BOUND         = -20;  // parameter out of bound
  public static final byte NO_ROOM_FOR_ENTITY         = -21;  // no room for new entities in this local TTCB
  public static final byte EID_NOT_IN_ELIST           = -22;  // (agreement)
  public static final byte TSTART_EXPIRED             = -23;  // (agreement)
  public static final byte MAX_NUM_AGREEMENTS_RUNNING  = -24;
  public static final byte VALUE_ALREADY_PROPOSED     = -25;  // an entity is trying to propose a value to a agreement to which it already did
  public static final byte INVALID_TAG		      = -26;
  public static final byte AGREEMENT_RUNNING 	      = -27;
  public static final byte INVALID_ID                 = -28;  // invalid eid, wrong secret, ...
  public static final byte INVALID_SEQ             = -29;     // invalid sequence number
  public static final byte INVALID_DECISION        = -30;     // (agreement)
  public static final byte DID_NOT_PROPOSE         = -31;     // (agreement)
  public static final byte NO_RESOURCES_PROPOSE    = -32;     // (agreement -- no resources for a propose)
  public static final byte INVALID_PROTECTION      = -33;     // invalid protection parameter
  public static final byte FAILED_LOCAL_AUTHENTICATION = -34;
  public static final byte AGREEMENT_EXPIRED       = -35;

// Java interface errors
  public static final byte JAVA_INTERFACE_ERROR    = -90;     // generic error (the same as returning null) 



// Some Constants
  public static final int MAX_LOCAL_ENTITIES         = 20;   // maximum n. of entities in a local TTCB
  public static final int MAX_SIZE_ELIST	      = 10;

// protection types
  public static final byte PROTECTION_NONE	              = 0;
  public static final byte PROTECTION_HMD5	              = 1;

  public static final short END_ELIST                  = 32767; 


// Agreement decisions
  public static final byte TTCB_TBA_RMULTICAST     = 0;
  public static final byte TTCB_TBA_MAJORITY     = 1;
  public static final byte TTCB_TBA_AND     = 2;
  public static final byte TTCB_TBA_OR     = 3;
  public static final byte TTCB_TBA_XOR     = 4;


// Size constants (in bytes)
  public static final int SIZE_SKEY = 16;
  public static final int SIZE_AKEY = 16;
  public static final int SIZE_CHALLENGE = 8;
  public static final int SIZE_VALUE = 20;
  public static final int SIZE_RANDOM = 16;

  public share_app_ttcb() {
  }
}
