/* ttcb_TTCB.c */

#define TTCB
#include "ttcb_TTCB.h"
#include "share_app_tcb.h"
#include "share_app_ttcb.h"



// Java interface specific errors
#define JAVA_INTERFACE_ERROR -90

#define END_ELIST_JAVA  32767    //different from the value with same meaning in C

// FALTA FAZER ESTA FUNCAO!!!!!

void back_descriptor(JNIEnv *env, jclass cl, jobject obj_desc, descriptor_t *descriptor)
{

  return;
}


// Prepare common input to TTCB call 
void translate_descriptor(JNIEnv *env, jclass cl, jobject obj_desc, descriptor_t *descriptor) 
{
  jfieldID fid;
  jbyteArray jarr;

  fid = (*env)->GetFieldID(env, cl, "desc_orig", "I");
  descriptor->desc_orig = (int)((*env)->GetIntField(env, obj_desc, fid));
 
  fid = (*env)->GetFieldID(env, cl, "wi_orig", "I");
  descriptor->wi_orig = (int)((*env)->GetIntField(env, obj_desc, fid));
 
  fid = (*env)->GetFieldID(env, cl, "eid", "S");
  descriptor->eid = (short)((*env)->GetShortField(env, obj_desc, fid));

  fid = (*env)->GetFieldID(env, cl, "protection", "B");
  descriptor->protection = (protection_t)((*env)->GetShortField(env, obj_desc, fid));

  fid = (*env)->GetFieldID(env, cl, "key", "[B");
  jarr = (*env)->GetObjectField(env, obj_desc, fid);
  (*env)->GetByteArrayRegion(env, jarr, 0, sizeof(skey_t), descriptor->secret);
  
  fid = (*env)->GetFieldID(env, cl, "seq", "S");
  descriptor->seq =  (short)((*env)->GetShortField(env, obj_desc, fid));
  (*env)->SetShortField(env, obj_desc, fid, descriptor->seq + 1);  

  return;
}




/*
 * Class:     ttcb_TTCB
 * Method:    openTCBConnection
 * Signature: (Lttcb/descriptor_t;)I
 */
JNIEXPORT jint JNICALL Java_ttcb_TTCB_openTCBConnection
  (JNIEnv *env, jobject obj, jobject obj_desc)
{
  jclass cl;
  jfieldID fid;
  descriptor_t descriptor;
  skey_t in_key;
  protection_t in_protection;
  challenge_t in_challenge;
  jbyteArray jarr;
  unsigned short tmp;
  int err=0;

  // TODO: here we should test if the input descriptor has a key, challenge, etc
  // and fill the C descriptor, instead of just zeroing it

  memset(&descriptor, 0, sizeof(descriptor_t));

  // call TTCB
  err = openTCBConnection(&descriptor);

  // translate descriptor to Java...
  cl = (*env)->GetObjectClass(env, obj_desc);

  fid = (*env)->GetFieldID(env, cl, "desc_orig", "I");
  if (fid == NULL) return -1;
  (*env)->SetIntField(env, obj_desc, fid, descriptor.desc_orig);
 
  fid = (*env)->GetFieldID(env, cl, "wi_orig", "I");
  if (fid == NULL) return -1;
  (*env)->SetIntField(env, obj_desc, fid, descriptor.wi_orig);

  fid = (*env)->GetFieldID(env, cl, "eid", "S");
  if (fid == NULL) return -1;
  (*env)->SetShortField(env, obj_desc, fid, descriptor.eid);

  fid = (*env)->GetFieldID(env, cl, "protection", "B");
  if (fid == NULL) return -1;
  (*env)->SetByteField(env, obj_desc, fid, descriptor.protection);

  fid = (*env)->GetFieldID(env, cl, "key", "[B");
  if (fid == NULL) return -1;
  jarr = (*env)->GetObjectField(env, obj_desc, fid);
  (*env)->SetByteArrayRegion(env, jarr, 0, sizeof(skey_t), descriptor.secret);

  fid = (*env)->GetFieldID(env, cl, "seq", "S");
  if (fid == NULL) return -1;
  (*env)->SetShortField(env, obj_desc, fid, tmp);
  descriptor.seq = (seq_t)tmp;

  return err;
}




/*
 * Class:     ttcb_TTCB
 * Method:    closeTCBConnection
 * Signature: (Lttcb/descriptor_t;)I
 */
JNIEXPORT jint JNICALL Java_ttcb_TTCB_closeTCBConnection
  (JNIEnv *env, jobject obj, jobject obj_desc)
{
  jclass cl;
  jfieldID fid;
  descriptor_t descriptor;

  if (obj_desc == NULL) return (jbyte)JAVA_INTERFACE_ERROR;

  if ((cl = (*env)->GetObjectClass(env, obj_desc)) == NULL)
    return (jbyte)JAVA_INTERFACE_ERROR;

  translate_descriptor(env, cl, obj_desc, &descriptor);

  return closeTCBConnection(&descriptor);
}



/*
 * Class:     ttcb_TTCB
 * Method:    getTCBGlobalTimestamp
 * Signature: (Lttcb/descriptor_t;Lttcb/timestamp_out_t;)I
 */
JNIEXPORT jint JNICALL Java_ttcb_TTCB_getTCBGlobalTimestamp
  (JNIEnv *env, jobject obj, jobject obj_desc, jobject obj_ts)
{
  jclass cl, cl_out;
  jfieldID fid;
  descriptor_t descriptor;
  eid_in_t in;
  long long timestamp; // TCBtimestamp
  int err;


  if (obj_desc == NULL) return -1;

  if ((cl = (*env)->GetObjectClass(env, obj_desc)) == NULL)
    return -1;

  if ((cl_out = (*env)->GetObjectClass(env, obj_ts)) == NULL)
    return -1;

  translate_descriptor(env, cl, obj_desc, &descriptor);

  err = getTCBGlobalTimestamp(&descriptor, &timestamp);

  
  //  if ((cl_out = (*env)->FindClass(env, "ttcb/timestamp_out_t")) == NULL)
  // return NULL;
  //  if ((obj_ts = (*env)->AllocObject(env, cl_out)) == NULL)
  //  return NULL;


  fid = (*env)->GetFieldID(env, cl_out, "ts", "J");
  if (fid == NULL) return -1;
  (*env)->SetLongField(env, obj_ts, fid, timestamp);

  return err;
}




/*
 * Class:     ttcb_TTCB
 * Method:    propose
 * Signature: (Lttcb/descriptor_t;[SJB[B)Lttcb/propose_out_t;
 */
JNIEXPORT jobject JNICALL Java_ttcb_TTCB_propose
  (JNIEnv *env, jobject obj, jobject obj_desc, jshortArray elist, jlong tstart, jbyte decision, jbyteArray value)
{
  jclass cl, cl_out;
  jfieldID fid;
  descriptor_t descriptor;
  protection_t encr;
  propose_out_t out;
  jobject obj_out;
  elist_t in_elist;
  value_t in_value;
  int i;

  if ((obj_desc == NULL) || (elist == NULL) || (value == NULL)) return NULL;

  if ((cl = (*env)->GetObjectClass(env, obj_desc)) == NULL)
    return NULL;

  translate_descriptor(env, cl, obj_desc, &descriptor);

  (*env)->GetShortArrayRegion(env, elist, 0, MAX_SIZE_ELIST, in_elist);
  for (i=0; i<MAX_SIZE_ELIST; i++) {
    if (in_elist[i] == END_ELIST_JAVA) {
      in_elist[i] = END_ELIST;
      break;
    }
  }
  (*env)->GetByteArrayRegion(env, value, 0, sizeof(value_t), in_value);

  propose(&descriptor, in_elist, tstart, decision, in_value, &out);

  if ((cl_out = (*env)->FindClass(env, "ttcb/propose_out_t")) == NULL)
    return NULL;
  if ((obj_out = (*env)->AllocObject(env, cl_out)) == NULL)
    return NULL;

  fid = (*env)->GetFieldID(env, cl_out, "error", "B");
  if (fid == NULL) return NULL;
  (*env)->SetByteField(env, obj_out, fid, out.error);

  fid = (*env)->GetFieldID(env, cl_out, "tag", "S");
  if (fid == NULL) return NULL;
  (*env)->SetShortField(env, obj_out, fid, out.tag);

  return obj_out;
}




/*
 * Class:     ttcb_TTCB
 * Method:    decide
 * Signature: (Lttcb/descriptor_t;S)Lttcb/decide_out_t;
 */
JNIEXPORT jobject JNICALL Java_ttcb_TTCB_decide
  (JNIEnv *env, jobject obj, jobject obj_desc, jshort tag)
{
  jclass cl, cl_out;
  jfieldID fid;
  descriptor_t descriptor;
  protection_t encr;
  jbyteArray jarr;
  jbooleanArray jarr_b;
  decide_out_t out;
  jobject obj_out;
  jmethodID cid;
  char mask_tmp[MAX_SIZE_ELIST];
  int i;
  mask_t bit;

  if (obj_desc == NULL) return NULL;

  if ((cl = (*env)->GetObjectClass(env, obj_desc)) == NULL)
    return NULL;

  translate_descriptor(env, cl, obj_desc, &descriptor);

  decide(&descriptor, tag, &out);

  if ((cl_out = (*env)->FindClass(env, "ttcb/decide_out_t")) == NULL)
    return NULL;
  if ((cid = (*env)->GetMethodID(env, cl_out, "<init>", "()V")) == NULL)
    return NULL;
  if ((obj_out = (*env)->NewObject(env, cl_out, cid, NULL)) == NULL)
    return NULL;

  fid = (*env)->GetFieldID(env, cl_out, "error", "B");
  if (fid == NULL) return NULL;
  (*env)->SetByteField(env, obj_out, fid, out.error);

  fid = (*env)->GetFieldID(env, cl_out, "value", "[B");
  if (fid == NULL) return NULL;
  jarr = (*env)->GetObjectField(env, obj_out, fid);
  (*env)->SetByteArrayRegion(env, jarr, 0, sizeof(value_t), out.value);

  fid = (*env)->GetFieldID(env, cl_out, "mask1", "[Z");
  if (fid == NULL) return NULL;
  jarr_b = (*env)->GetObjectField(env, obj_out, fid);
  if (jarr_b == NULL) return NULL;
  bit = 1;
  for (i = 0; i < MAX_SIZE_ELIST; i++) {
    if ((bit & out.mask1) == 0)
      mask_tmp[i] = 0;
    else
      mask_tmp[i] = 1;
    bit = bit << 1;
  } 
  (*env)->SetBooleanArrayRegion(env, jarr_b, 0, MAX_SIZE_ELIST, mask_tmp);

  fid = (*env)->GetFieldID(env, cl_out, "mask2", "[Z");
  if (fid == NULL) return NULL;
  jarr_b = (*env)->GetObjectField(env, obj_out, fid);
  if (jarr_b == NULL) return NULL;
  bit = 1;
  for (i = 0; i < MAX_SIZE_ELIST; i++) {
    if ((bit & out.mask2) == 0)
      mask_tmp[i] = 0;
    else
      mask_tmp[i] = 1;
    bit = bit << 1;
  } 
  (*env)->SetBooleanArrayRegion(env, jarr_b, 0, MAX_SIZE_ELIST, mask_tmp);

  return obj_out;
}





/*
 * Class:     ttcb_TTCB
 * Method:    getRandom
 * Signature: (Lttcb/descriptor_t;)Lttcb/rand_out_t;
 */

/*
JNIEXPORT jobject JNICALL Java_ttcb_TTCB_getRandom
  (JNIEnv *env, jobject obj, jobject obj_desc)
{
  jclass cl, cl_out;
  jfieldID fid;
  descriptor_t descriptor;
  protection_t encr;
  jbyteArray jarr;
  jmethodID cid;
  rand_out_t out;
  jobject obj_out;

  if (obj_desc == NULL) return (jint)JAVA_INTERFACE_ERROR;

  if ((cl = (*env)->GetObjectClass(env, obj_desc)) == NULL)
    return NULL;

  translate_descriptor(env, cl, obj_desc, &descriptor);

  getRandom(&descriptor, &out);

  if ((cl_out = (*env)->FindClass(env, "ttcb/random_out_t")) == NULL)
    return NULL;
  if ((cid = (*env)->GetMethodID(env, cl_out, "<init>", "()V")) == NULL)
    return NULL;
  if ((obj_out = (*env)->NewObject(env, cl_out, cid, NULL)) == NULL)
    return NULL;

  fid = (*env)->GetFieldID(env, cl_out, "error", "B");
  (*env)->SetByteField(env, obj_out, fid, out.error);

  fid = (*env)->GetFieldID(env, cl_out, "random", "[B");
  jarr = (*env)->GetObjectField(env, obj_out, fid);
  (*env)->SetByteArrayRegion(env, jarr, 0, sizeof(radom_t), out.random);

  return obj_out;
}
*/






/*
 * Class:     ttcb_TTCB
 * Method:    crashedLocalTTCBeid
 * Signature: (Lttcb/descriptor_t;S)B
 */

/*
JNIEXPORT jbyte JNICALL Java_ttcb_TTCB_crashedLocalTTCBeid
  (JNIEnv *env, jobject obj, jobject obj_desc, jshort eid)
{
  jclass cl;
  descriptor_t descriptor;
  error_out_t out;
  protection_t encr;

  if (obj_desc == NULL) return (jint)JAVA_INTERFACE_ERROR;

  if ((cl = (*env)->GetObjectClass(env, obj_desc)) == NULL)
    return JAVA_INTERFACE_ERROR;

  translate_descriptor(env, cl, obj_desc, &descriptor);

  crashedLocalTTCBeid(&descriptor, &out);

  return out.error;
}
*/



