/*	 
	Process configuration 

	Pedro Martins <pmartins@di.fc.ul.pt>

--[TCB 1.1]----------------------------------------------------

    (Trusted) Timely Computing Base 1.1
    (C) 1999-2003, Navigators Group 
    		   http://www.navigators.di.fc.ul.pt
    
-----------------------------------------------------------------	
*/

#include "../autoconf.h"
#include <stdlib.h>
#include <stdio.h>
#include "tcb/param.h"

FILE* fd,*fd2,*fd3,*fd4;

int main(int argc, char* argv[])
{
	int i;

	fd=fopen("include/tcb/system_defs.h","w");
	if (fd==NULL)
	{
		printf("Error on creating the TCB configuration file\n");
		exit(1);
	}
	
	fd3=fopen("install.config","w");
	if (fd3==NULL)
	{
		printf("Error on creating the TCB configuration file\n");
		exit(1);
	}
	
	fd2=fopen("include/tcb/rt_net_addrs.h","w");
	if (fd2==NULL)
	{
		printf("Error on creating the TCB configuration file\n");
		exit(1);
	}
	
	fd4=fopen("kernel/create_fifos","w");
	if (fd4==NULL)
	{
		printf("Error on creating the TCB configuration file\n");
		exit(1);
	}	
	fprintf(fd,"/* TCB configuration file\n");
	fprintf(fd,"   Generated by process_config... don't edit this file */\n\n\n");

	#ifdef CONFIG_TTCB
	fprintf(fd3,"TTCB=1\n");
	fprintf(fd,"#define TTCB\n");
	#else
	fprintf(fd3,"TTCB=0\n");
	fprintf(fd,"#undef TTCB\n");
	#endif	
        #ifdef CONFIG_JAVAAPI
	fprintf(fd3,"JAVAAPI=1\n");
	#else
	fprintf(fd3,"JAVAAPI=0\n");
        #endif
	#ifdef CONFIG_LOCAL_MEASURE
	fprintf(fd3,"LOCALMEASURE=1\n");
	fprintf(fd,"#define LOCAL_MEASURE\n");
	#else
	fprintf(fd3,"LOCALMEASURE=0\n");
	fprintf(fd,"#undef LOCAL_MEASURE\n");
	#endif
	#ifdef CONFIG_LOCAL_TIMELY
	fprintf(fd3,"LOCALTIMELY=1\n");
	fprintf(fd,"#define LOCAL_TIMELY\n");
	fprintf(fd,"#define NEED_FUNC_ERR\n");
	#else
	fprintf(fd3,"LOCALTIMELY=0\n");
	fprintf(fd,"#undef LOCAL_TIMELY\n");
	#endif
	#ifdef CONFIG_LOCAL_FAULT
	fprintf(fd3,"LOCALFAULT=1\n");
	fprintf(fd,"#define LOCAL_FAULT\n");
	fprintf(fd,"#define NEED_FUNC_ERR\n");
	#else
	fprintf(fd3,"LOCALFAULT=0\n");
	fprintf(fd,"#undef LOCAL_FAULT\n");
	#endif
	#ifdef CONFIG_LOCAL_RANDOM
	fprintf(fd3,"LOCALRANDOM=1\n");
	fprintf(fd,"#define LOCAL_RANDOM\n");
	#else
	fprintf(fd3,"LOCALRANDOM=0\n");
	fprintf(fd,"#undef LOCAL_RANDOM\n");
	#endif
	#ifdef CONFIG_DIST_SERVICES
	fprintf(fd3,"DISTRIBUTED=1\n");
	fprintf(fd,"#define DISTRIBUTED\n");
	#else
	fprintf(fd3,"DISTRIBUTED=0\n");
	fprintf(fd,"#undef DISTRIBUTED\n");
	#define CONFIG_CC_LO
	#endif
	#ifdef CONFIG_DIST_MEASURE
	fprintf(fd3,"DISTMEASURE=1\n");
	fprintf(fd,"#define DIST_MEASURE\n");
	#else
	fprintf(fd3,"DISTMEASURE=0\n");
	fprintf(fd,"#undef DIST_MEASURE\n");
	#endif
	#ifdef CONFIG_DIST_FAULT
	fprintf(fd3,"DISTFAULT=1\n");
	fprintf(fd,"#define DIST_FAULT\n");
	fprintf(fd,"#define NEED_FUNC_ERR\n");
	#else
	fprintf(fd3,"DISTFAULT=0\n");
	fprintf(fd,"#undef DIST_FAULT\n");
	#endif
	#ifdef CONFIG_DIST_AGREEMENT
	fprintf(fd3,"DISTAGREEMENT=1\n");
	fprintf(fd,"#define DIST_AGREEMENT\n");
	#else
	fprintf(fd3,"DISTAGREEMENT=0\n");
	fprintf(fd,"#undef DIST_AGREEMENT\n");
	#endif
	#ifdef CONFIG_CC_LO
	fprintf(fd,"#define IP_BROADCAST_ADDR INADDR_LOOPBACK\n");
	fprintf(fd,"#define NETDEV lo\n");
	fprintf(fd,"#define NETDEVICE_NUMB 0\n");	
	fprintf(fd3,"NETDEV=lo_device\n");
	fprintf(fd,"#define NUMBER_OF_MACHINES 1\n");
	fprintf(fd2,"case 0 : return 0;\n"); 
	#endif
	#ifdef CONFIG_CC_3COM
	fprintf(fd,"#define IP_BROADCAST_ADDR INADDR_BROADCAST\n");
	fprintf(fd,"#define NETDEV 3com\n");
	fprintf(fd,"#define NETDEVICE_NUMB 1\n");
	fprintf(fd3,"NETDEV=3com_device\n");
	fprintf(fd3,"LINUXIFACE=%s\n",CONFIG_3COM_IFACE);
	fprintf(fd,"#define RT_CARD_LINUX_IFACE	%s\n",CONFIG_3COM_IFACE);
	#endif
	#ifdef CONFIG_CC_3COM_NOM
	fprintf(fd,"#define NUMBER_OF_MACHINES %d\n",CONFIG_CC_3COM_NOM);	
	i=0;
	if (i==CONFIG_CC_3COM_NOM)
	{
	}
	  else
	   {
	     fprintf(fd2,"case  0x%X: return 0;\n",CONFIG_CC_3COM_MACADDR_1);i++; 	
	     if (i==CONFIG_CC_3COM_NOM)
		{
		}
		  else
	   	{
	     	fprintf(fd2,"case  0x%X: return 1;\n",CONFIG_CC_3COM_MACADDR_2);i++; 	
		if (i==CONFIG_CC_3COM_NOM)
		{}
		  else
	   	{
	     	fprintf(fd2,"case  0x%X: return 2;\n",CONFIG_CC_3COM_MACADDR_3);i++; 			     		     
	     	if (i==CONFIG_CC_3COM_NOM)
		{}
		  else
	   	{
	     	fprintf(fd2,"case  0x%X: return 3;\n",CONFIG_CC_3COM_MACADDR_4);i++; 			     		     
	     	if (i==CONFIG_CC_3COM_NOM)
		{}
		  else
	   	{
	     	fprintf(fd2,"case  0x%X: return 4;\n",CONFIG_CC_3COM_MACADDR_5);i++; 			     		     	     	
		if (i==CONFIG_CC_3COM_NOM)
		{}
		  else
	   	{
	     	fprintf(fd2,"case  0x%X: return 5;\n",CONFIG_CC_3COM_MACADDR_6);i++; 			     		     	     			
	   	}
	   	}
	   	
	   	}	   	      		     
	   	}
	   	}	  
	}
	fprintf(fd2,"\n\n");
	#endif
	fprintf(fd3,"RTAI_DIR=%s\n",CONFIG_RTAIDIR);
	#ifdef CONFIG_SC_CC_SIMULATED
	fprintf(fd,"#define CONFIG_SELF_CHECKING_CONTROL_CHANNEL_SIMULATED 1\n");
	#endif	
	#ifdef CONFIG_SC_CC_REAL
	fprintf(fd,"#define CONFIG_SELF_CHECKING_CONTROL_CHANNEL_REAL 1\n");
	#endif
	fprintf(fd,"#define MAX_EXEC		%u\n",CONFIG_MAX_EXEC);
	fprintf(fd,"#define MAX_LOCAL_FD	%u\n",CONFIG_MAX_LFD);	
	fprintf(fd,"#define MAX_TCB_CONNECTIONS	%u\n",CONFIG_MAX_TCB_CONNECTIONS);		
	#ifdef CONFIG_NODRIFT
	fprintf(fd,"#define CLOCK_DRIFT_RATE 0\n");	
	#endif
	#ifdef CONFIG_DRIFT2
	fprintf(fd,"#define CLOCK_DRIFT_RATE 0.05\n");	
	#endif
	#ifdef CONFIG_DRIFT3
	fprintf(fd,"#define CLOCK_DRIFT_RATE 0.005\n");	
	#endif
	#ifdef CONFIG_DRIFT4
	fprintf(fd,"#define CLOCK_DRIFT_RATE 0.0005\n");	
	#endif
	#ifdef CONFIG_DRIFT5
	fprintf(fd,"#define CLOCK_DRIFT_RATE 0.00005\n");	
	#endif
	#ifdef CONFIG_DRIFT6
	fprintf(fd,"#define CLOCK_DRIFT_RATE 0.000005\n");			
	#endif	
	#ifdef CONFIG_DRIFT7
	fprintf(fd,"#define CLOCK_DRIFT_RATE 0.0000005\n");			
	#endif		
	#ifdef CONFIG_DRIFT8
	fprintf(fd,"#define CLOCK_DRIFT_RATE 0.00000005\n");			
	#endif	
	fprintf(fd,"#define MINIMUM_DELIVERY_DELAY %d\n",CONFIG_PL_MINIMUM);	
	//generate create rtfifos script file
	fprintf(fd4,"mknod /dev/rtf0 c 150 0\n");	
	fprintf(fd4,"mknod /dev/rtf%u c 150 %u\n",TCB_REQ_FIFO,TCB_REQ_FIFO);
	for (i=0;i<CONFIG_MAX_TCB_CONNECTIONS;i++){
		fprintf(fd4,"mknod /dev/rtf%u c 150 %u\n",i+TCB_CON_STARTFIFO,i+TCB_CON_STARTFIFO);
	}
	for (i=0;i<CONFIG_MAX_TCB_CONNECTIONS;i++){
		fprintf(fd4,"mknod /dev/rtf%u c 150 %u\n",i+TCB_CON_STARTFIFO+CONFIG_MAX_TCB_CONNECTIONS,i+TCB_CON_STARTFIFO+CONFIG_MAX_TCB_CONNECTIONS);
	}	
	fclose(fd);
	fclose(fd2);
	fclose(fd3);
	fclose(fd4); 	
	return 0;
}

